import Parsing.MainParsing
import Parsing.SyntaxParser
import Syntaxes.BasicCore
import Process.Result
import Parsing.SrcLoc


main = parse basicCoreSyntax "examples/ex1.txt"

main_syn = parse syntax_def "examples/basic_core.txt"


pr = parseRule (syntaxParser syntax_def)



showR :: (Show a, Show b) => Result [a] [b] -> String
showR (Success s) = "Success:\n" ++ unlines (map show s)
showR (Failure f) = "Failure:\n" ++ unlines (map show f)

parse syntax file = let
	parser = syntaxParser syntax
	in do
		text <- readFile file
		putStrLn ("File processed: " ++ file)
		putStrLn ""
	
		putStrLn "Result of parsing:"
		parsed <- return $ (parseText parser) text
		putStrLn (showR parsed)

